<?php

/*

 $Id: flo.php,v 1.15.2.1 2004/02/29 09:56:25 vollmerk Exp $
 $Source: /data/cvsroot/maintain/modules/class/flo.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Flo Module Class
	This is the flow object... for use when doing flo mojo

*/

class Flo {

	var $id;
	var $ip;
	var $host; //a host object...
	var $date;
	var $in_kb;
	var $out_kb;
	var $in_packets;
	var $out_packets;
	var $abuse;
	var $abuse_to; //not in db this is grabbed from reg maintain used for sending out e-mails
	

	function Flo ($id=0) {

		//if they've passed an id set the vars
		if ($id) {
			$this->id = $id;
			$info = $this->get_info($this->id);
			$this->ip           = $info->ip;
			$this->host 	    = new Host($info->host);			
			$this->date         = $info->date;
			$this->in_kb        = $info->in_kb;
			$this->out_kb       = $info->out_kb;
			$this->in_packets   = $info->in_packets;
			$this->out_packets  = $info->out_packets;
			$this->abuse        = $info->abuse;
		} //end if ID

		
	} // Flo	

	//basic get_info mojo
	function get_info() {
		global $conf;

		$info = $conf['modules']->get_info("flo");
	
		$sql = "SELECT * FROM bandwidth_usage WHERE id='$this->id'";
		$db_results = mysql_query($sql, $info['dbh']);

		$info = mysql_fetch_object($db_results);

		//get the mojo for the host object we need to create
		$sql = "SELECT * FROM host WHERE ip='$info->ip'";
		$db_results = mysql_query($sql, $conf['dbh']);
	
		$object = mysql_fetch_object($db_results);
		$info->host = $object->id;

		return $info;

	} //get_info

	//gets the inbound flows for $hosts which is an array of objects
	//for the specifed date
	function get_top_in_flos($hosts,$date) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		//cycle through and get the info!
		foreach ($hosts as $host) {
			$sql = "SELECT * FROM bandwidth_usage WHERE ip='$host->ip->ip_int' AND date='$date' ORDER BY in_kb DESC";
			$db_results = mysql_query($sql, $info['dbh']);
			
			$r = mysql_fetch_object($db_results); 
			if ($r) { $flos[] = $r; }
		} //end foreach

	return $flos;

	} //get_in_flos

        //gets all flos for $hosts which is an array of objects
        //for the specifed date
        function get_flos($hosts,$date=0) {
                global $conf;

		$info = $conf['modules']->get_info("flo");

                //cycle through and get the info!
                foreach ($hosts as $host) {
			$ip_int = $host->ip->ip_int;
			if ($date) {
	                        $sql = "SELECT * FROM bandwidth_usage WHERE ip='$ip_int' AND date='$date'";
			}
			else {
				$sql = "SELECT * FROM bandwidth_usage WHERE ip='$ip_int' ORDER BY date DESC";
			}
                        $db_results = mysql_query($sql, $info['dbh']);
                        $r = mysql_fetch_object($db_results); 
                        if ($r) { $flos[] = new Flo($r->id); }
                } //end foreach

        return $flos;

        } //get_flos


	/*
		@function get_host_flows
		@discussion gets the flows for a specific host, based on ip address or dynamic range
	*/
	function get_host_flows($host, $limit=0){
	
		global $conf;

		$info = $conf['modules']->get_info("flo");

		// If this is a static host no questions asked
		if ($host->ip->ip_int) { 
			$sql = "SELECT * FROM bandwidth_usage WHERE ip='". $host->ip->ip_int ."'";
		}

		// Crapo this is dynamic, insert special mojo here
		else {
			$ips = $host->get_history_ips();
			$sql = "SELECT * FROM bandwidth_usage WHERE";
			foreach ($ips as $ip) {
				if ($wo) { $sql .= " OR "; }
				$sql .= " ( ip='" . $ip->int . "' AND date <= '" . $ip->end . "' AND date >= '" . $ip->start . "' )";
				$wo = 1;
			} // end foreach ips

		} // else it's dynamic

		// If we have a limit
		if ($limit) {
			$sql .= " ORDER BY date DESC LIMIT 0,$limit"; 
		}
		else {
			$sql .= " ORDER BY date DESC"; 
		}
		$db_results = mysql_query($sql, $info['dbh']);
		
		//fill an array of objects
		while ($f = mysql_fetch_object($db_results)) {
			$flo = new Flo($f->id);
			$flows[] = $flo;
		}
	return $flows;

	} //get_host_flows


	//get the flows for a specified zone
	//this generates a big sql statement to search all range
	//in the specifed zone can have a field and limit 
	function get_zone_flows($zone_id,$date,$field=0,$limit=0) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		//first get an array of the ranges that this zone contains
		$sql = "SELECT ranges.* FROM ranges,zone_range WHERE ranges.id=zone_range.range AND zone_range.zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($r = mysql_fetch_object($db_results)) {
			$ranges[] = new Range($r->id);
		} //end while
		
		//base sql statement for bandwidth
		$sql = "SELECT * FROM bandwidth_usage WHERE date='$date' AND ( ";
		
		foreach ($ranges as $range) {
			//if this isn't the first time through then go ahead and add a OR
			if ($first) { $sql .= " OR "; }
			$start = $range->start->ip_int;
			$end = $range->end->ip_int;
			$sql .= "(ip>='$start' AND ip<='$end')";
			$first = 1;
		} //foreach
		
		//append the order by!
		if ($field) { $sql .= " ) ORDER BY $field DESC"; }
		else { $sql .= " ) ORDER BY out_kb DESC"; }

		//if there is a limit append it to the sql statement
		if ($limit) { $sql .= " LIMIT $limit"; }
		
		//ok now setup the query and run it!
		$db_results = mysql_query($sql, $info['dbh']);
		
		while ($r = mysql_fetch_object($db_results)) { 
			$flos[] = new Flo($r->id);
		}

	return $flos;

	} //get_zone_flows

        //get the flows for a specified range
        function get_range_flows($range_id,$date,$field=0,$limit=0) {
                global $conf;

		$info = $conf['modules']->get_info("flo");

                //first get an array of the ranges that this zone contains
                $sql = "SELECT ranges.*  FROM ranges WHERE ranges.id='$range_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$r = mysql_fetch_object($db_results);
		$end = $r->end;
		$start = $r->start;

		$sql = "SELECT * FROM bandwidth_usage WHERE ip<=$end AND ip>=$start AND date=$date";	
	
                //append the order by!
                if ($field) { $sql .= " ORDER BY $field DESC"; }
                else { $sql .= " ORDER BY out_kb DESC"; }

                //if there is a limit append it to the sql statement
                if ($limit) { $sql .= " LIMIT $limit"; }

                //ok now setup the query and run it!
                $db_results = mysql_query($sql, $info['dbh']);

                while ($r = mysql_fetch_object($db_results)) {
                        $flos[] = new Flo($r->id);
                }   

        return $flos;

        } //get_range_flows


	//color the flows depending upon the amount of data is pushes... limits are defined in conf
	function color_data($data) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		if ($data >= $info['lv4']) {
			$color = $info['color_lv4'];
			}
		elseif ($data >= $info['lv3']) {
			$color = $info['color_lv3'];
			}
		elseif ($data >= $info['lv2']) {
			$color = $info['color_lv2'];
			}
		elseif ($data >= $info['lv1']) {
			$color = $info['color_lv1'];
			}
		else {
			$color = '';
		}

		//make sure we commify it!
		$data = commify($data);
	
	return "<font color=\"". $color . "\">". $data . "</font>";

	} //color_data


	//check and see if a specific host has any flo data
	function check_for_flo($ip_int=0,$host=0) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		// If they passed in information about a static 
		if ($ip_int) {
			$sql = "SELECT * FROM bandwidth_usage WHERE ip='$ip_int'";
			
			$db_results = mysql_query($sql, $info['dbh']);
			$results = mysql_fetch_object($db_results);
		} // if ip_int

		// If they passed a host they are going dynamic!.. this get's ugly!
		elseif ($host) {

			// First things first let's all the IP addresses and times
			$sql = "SELECT * FROM host_history WHERE ha LIKE '" . $host->ha . "'";
			$db_results = mysql_query($sql, dbh());

			while ($data = mysql_fetch_object($db_results)) {
				$sql = "SELECT * FROM bandwidth_usage WHERE ip='$data->ip'";
				$db_results = mysql_query($sql, $info['dbh']);
				if ($results = mysql_fetch_object($db_results)) {
					return results;
				}
			
			} // while loop checking host history

		} // dynamic_range
		
		
	} //check_for_flo

	//displays the flows for one host over time
	function show_single_host_flow($flows) {
		global $user, $conf;

		require ($conf['prefix'] . "/templates/show_flo.inc");

	} //show_single_host_flow

	//displays the flows for one host over time
        function show_single_host_flo_graph($title, $filename) {
                global $user, $conf;

                require ($conf['prefix'] . "/templates/show_flo_graph.inc");
        } // show_single_host_flo_graph	

	//show date select
	function show_date_select($name=0) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		$sql = "SELECT DISTINCT(date) FROM bandwidth_usage ORDER BY date DESC";
		$db_results = mysql_query($sql, $info['dbh']);
		
		//ehco the mofo's out!
		if ($name) {
			echo "<select name=\"$name\">";
			}
		else {
			echo "<select name=\"date\">";
		}
		while ($object = mysql_fetch_object($db_results)) {
			echo $object->date . " is date";
			echo "<option value=\"$object->date\">". date("F j, Y", $object->date) . "</option>";
			}
		echo "</select>";
	} //show_date_select

	//get an array of the top inbound flows
	function get_top_in_flows($date,$total=0) {
		global $conf;
		
		$info = $conf['modules']->get_info("flo");

		//if they don't set a total then go ahead and set it to the default
		if (!$total) { $total = $info['top_count']; }

		$sql = "SELECT * FROM bandwidth_usage WHERE date='$date' ORDER BY in_kb DESC LIMIT 0,$total";
		$db_results = mysql_query($sql, $info['dbh']);

		while ($object = mysql_fetch_object($db_results)) {
			$flo = new Flo($object->id);
			$in_flows[] = $flo;
		} //end gather of inbound flows

		return $in_flows;

	} //get_top_in_flows

	//get an array of the top outbound flows
	function get_top_out_flows($date, $total=0) {
		global $conf;
	
		$info = $conf['modules']->get_info("flo");

		//if they don't set a total then go ahead and set it to the default
		if (!$total) { $total = $info['top_count']; }

                $sql = "SELECT * FROM bandwidth_usage WHERE date='$date' ORDER BY out_kb DESC LIMIT 0,$total";
                $db_results = mysql_query($sql, $info['dbh']);

                while ($object = mysql_fetch_object($db_results)) {
                        $flo = new Flo($object->id);  
                        $out_flows[] = $flo;
                } //end gather of outbound flows
	
		return $out_flows;
	
	} //get_top_out_flows

	//show the flows
	function show_flows($in_flows=0,$out_flows=0,$hog=0,$date) {
		global $conf,$user;

		require ($conf['prefix'] . "/templates/show_flos.inc");

	} //show_flows

	// pass a Host object and an array of flows for that host
	function graph( $title, $subtitle, $filename, $flows ) {
		global $conf;

		$info = $conf['modules']->get_info("flo");

		include ($conf['prefix'] . "/modules/jpgraph/jpgraph.php");
		include ($conf['prefix'] . "/modules/jpgraph/jpgraph_line.php");

		// Start with the date of the 1st record, end today. 
		$startTS = $flows[0]->date;
		$endTS = time();

		$tick = 0;  $i = 0;
		$flows = array_reverse($flows);

		foreach ($flows as $flo) {
    			$day_in[$i]  = $flo->in_kb / 1000000;
    			$day_out[$i] = $flo->out_kb / 1000000;

        		if( ($i%$info['graph_tick']) == 0)
        		{
            			$DayName[$tick++] = date('M-d',$flo->date);
        		}
    			else {
				$DayName[$tick++] = "";
			}

    			$i++;
		}

		// instanciate graph:
		$graph = new Graph($info['graph_width'],
					$info['graph_height']);

		$graph->SetScale("textlin");
		$graph->SetBackgroundImage($conf['prefix'] . "/docs/images/backdrop.png",BGIMG_COPY);

		$graph->img->SetAntiAliasing();
		$graph->SetShadow();
		$graph->SetMarginColor("white");

		$graph->xaxis->SetTickLabels($DayName);
		$graph->img->SetMargin(60,30,20,50);
		$graph->xgrid->Show(true,false);

		$graph->SetColor("#ffffcc");

		// Set A title for the plot
		$graph->title->Set($title);
		$graph->subtitle->Set($subtitle);
		$graph->title->SetFont(FF_FONT2, FS_BOLD);

		$graph->legend->SetFont(FF_FONT2, FS_NORMAL);
		$graph->legend->Pos(0.50 ,0.95,"center","bottom");
		$graph->legend->SetLayout(LEGEND_HOR);

		// Create graph
		$p1 = new LinePlot($day_in);
		$p2 = new LinePlot($day_out);

		$p1->SetColor("orange");
		$p1->SetFillColor("orange");

		$p2->SetColor("blue");
		$p1->SetWeight(3);
		$p2->SetWeight(2);
		//$p1->SetStepStyle();

		$p1->SetLegend("Inbound");
		$p2->SetLegend("Outbound");

		$graph->Add($p1);
		$graph->Add($p2);

		// Display the graph
		$graph->Stroke($info['graph_path']. "/$filename.jpg");
	}
} // class Flo
?>
