<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: widget.php,v 1.40 2003/12/11 22:50:34 vollmerk Exp $
 $Source: /data/cvsroot/maintain/modules/class/widget.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Widget Class
	This class holds all the widget we use in maintain. This it put
	in here simply so ui doesn't get really big. You access widget
	by doing $conf['ui']->widget->[WIDGET]; We don't need a constructor
*/

class Widget {

	var $items; //the array of items
	var $title; //the title for the widget
	var $type; //the type of widget we are generating
	var $width; //the width of the widget table

		

        function admin_edit() {
                global $conf, $user;

		if (!$user->is_admin) {
			return false;
		}

                $width = "100%";

                $zone_id = $conf['zone']->id;

		$items[] = "Manage IP Blocks: " . 
				"<a href=\"" . $conf['web_path'] . "/ip.php?action=show_ip_blocks\">List</a> | " .
				"<a href=\"" . $conf['web_path'] . "/ip.php?action=show_add_ip\">Create</a>";
                $items[] = "Manage Subnets: ".
                                "<a href=\"" . $conf['web_path'] . "/subnet.php?action=show_subnets\">List</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/subnet.php?action=show_create\">Create</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/subnet.php?action=show_unused_subnets\">Available</a>";

                $items[] = "Manage Workgroups: ".
                                "<a href=\"" . $conf['web_path'] . "/workgroup.php?action=show_workgroups\">List</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/workgroup.php?action=show_create\">Create</a>";

                $items[] = "Manage Domains: ".
                                "<a href=\"" . $conf['web_path'] . "/domain.php?action=show_domains\">List</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/create_domain.php\">Create</a>";

                $items[] = "Manage IP Ranges: ".
                                "<a href=\"" . $conf['web_path'] . "/range.php?action=show_ranges\">List</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/range.php?action=show_create\">Create</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/range.php?action=show_unused_ranges\">List Unused</a>";

                $items[] = "Manage VLAN's: ".
                                "<a href=\"" . $conf['web_path'] . "/vlan.php?action=show_vlans\">List</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/vlan.php?action=show_create\">Create</a>";
/* This is dead code
                $items[] = "Staging Permissions: ".
                                "<a href=\"" . $conf['web_path'] . "/staging.php?action=show_stagings\">List</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/staging.php?action=show_create\">Create</a>";
*/
		$conf['ui']->display_widget($items,"Network Tools",$width);
		echo "<br />";
		$items = array();

                //setup the links
                $items[] = "Zone Tools: ".
                                "<a href=\"" . $conf['web_path'] . "/zone.php?action=edit&amp;zone_id=$zone_id\">Edit Current</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_zones\">List</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/create_zone.php\">Create</a> | ".
                                "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_merge_zone\">Merge</a>";
		$items[] = "Manage Hosts: ".
                                "<a href=\"" . $conf['web_path'] . "/host.php?action=select_bulk_hosts_zone_move\">Bulk Host Zone Move</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/range.php?action=show_batch_move\">Batch Host Move</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/range.php?action=show_range_host_copy\">Batch Host Copy";

                if ($conf['modules']->modules['flo']->enabled ) {
	
			$info = $conf['modules']->get_info("flo");

                //generate yesterdays date exactly.. 
                $date = strtotime ("-1 day 23:59:00");

                $items[] = "%TBandwidth Reports:";

                $items[] = "Global: " .
                                "<a href=\"". $conf['web_path'] . "/modules/flo.php?action=show_top\">Select</a> | ".
                                "<a href=\"". $conf['web_path'] . "/modules/flo.php?action=show_top&amp;date=". $date . "&amp;count=".$info['top_count']."\">Top ". $info['top_count']."</a>";
                $items[] = "Zone: " .
                                "<a href=\"". $conf['web_path'] . "/modules/flo.php?action=show_top_zone\">Select</a> | ".
                                "<a href=\"". $conf['web_path'] . "/modules/flo.php?action=show_top_zone&amp;date=$date&amp;count=".$info['top_count']."&amp;zone_id=".$conf['zone']->id."\">Top " . $conf['modules_flo_top_count']. "</a>";
                $items[] = "Range: " .
                                "<a href=\"". $conf['web_path'] . "/modules/flo.php?action=show_top_range\">Select</a>";
                } //end check for enabled flo module
                $items[] = "Help Documents: " .
                                "<a href=\"" . $conf['web_path'] . "/help.php?action=create\">Create</a> | " .
                                "<a href=\"" . $conf['web_path'] . "/help.php?action=view\">List</a>";


		$conf['ui']->display_widget($items,"Misc. Tools",$width);
		/*******************************************************/
		echo "<br />";
		$items = array();

                // setup the links
                $items[] = "<a href=\"" . $conf['web_path'] . "/user.php?action=show_add_user\">Add user to current zone</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/user.php?action=show_users\">View/Edit/Delete Users from current zone</a>";
                //display purge mojo if the zone is purgeable!
                if ($conf['zone']->purgeable == "true") {
                        $items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=purge&amp;zone_id=" . $conf['zone']->id . "\">Purge Hosts</a>";
                        }
                // this zone is purgeable so show that to the user
                if ( $conf['zone']->purge ) {
                        $zone_id = $conf['zone']->id;
                        $items[] = "<a href=\"" . $conf['web_path'] . "/admin.php?action=purge_zone&amp;zone_id=$zone_id\">Purge this zone</a>";
                }

		if ($conf['ui']->mysql_auth()) { 			
		$items[] = "Manage Local Users: " .
				"<a href=\"" . $conf['web_path'] . "/user.php?action=show_local_users\">List</a> | " .
				"<a href=\"" . $conf['web_path'] . "/user.php?action=show_create_mysql_user\">Create</a>";
	
		} // if they have mysql_auth
		$items[] = "<a href=\"" . $conf['web_path'] . "/admin.php?action=show_make_admin\">Add Full Administrator</a>";

		$conf['ui']->display_widget($items,"User Tools",$width);

//		$items[] = "%T<a href=\"". $conf['web_path'] . "/admin.php?action=new_network\">New Network Wizard</a>";

        } // admin_edit

        // global statistics
        function global_stats () {
		global $conf;
		
                $zone_count = count_zone();
                $domain_count = count_domain();
                $cname_count = count_cname();
                $mx_count = count_mx();
                $user_count = count_user();
                $dynamic_count = count_dynamic_ip();
                $static_count = count_static_ip();
                $host_count = count_host();
		$pointer_count = count_pointer();

                $items[] = "Zones: <b>" . commify($zone_count) . "</b>";
                $items[] = "Domains: <b>" . commify($domain_count) . "</b>";
                $items[] = "CNAME Records: <b>" . commify($cname_count) . "</b>";
                $items[] = "MX Records: <b>" . commify($mx_count) . "</b>";
		$items[] = "Pointer Records: <b>" . commify($pointer_count) . "</b>";
                $items[] = "Hosts w/ Dynamic IP's: <b>" . commify($dynamic_count) . "</b>";
                $items[] = "Hosts w/ Static IP's: <b>" . commify($static_count) . "</b>";
                $items[] = "Total Hosts: <b>" .commify($host_count) . "</b>";
                $items[] = "Active Maintain Users: <b>" . commify($user_count) . "</b>";

                $conf['ui']->display_widget($items, "Current Global Statistics", "100%");
        } // global_stats

       // Display the Help information widget
        // nothing needs to be passed in
        function zone_information($type = 0)
        {
                global $conf, $user;

                // setup the table
                $width = "100%";

                // setup the information

                // setup the links
                if (!$type) {
                $host_count = count_host($conf['zone']->id);
                $cname_count = count_cname($conf['zone']->id);
                $mx_count = count_mx($conf['zone']->id);
                $domain_count = count_domain($conf['zone']->id);
		$pointer_count = count_pointer($conf['zone']->id);

                $items[] = "There are " . commify($host_count) . " Hosts in this zone";
                $items[] = "There are " . commify($cname_count) . " CNAMES in this zone";
                $items[] = "There are " . commify($mx_count) . " MX Records in this zone";
		$items[] = "There are " . commify($pointer_count) . " Pointers in this zone";
                $items[] = "There are " . commify($domain_count) . " Domains in this zone";


                $conf['ui']->display_widget($items,"Zone Information",$width);

                } // read only
         
		// show the zone_edit information
	       else {

                //check to see if we need the migrate button
                $all_domains = $conf['zone']->domains();
		


                if ($conf['modules']->modules['domain']->enabled AND $conf['ui']->orst_domains($all_domains) AND ( $user->is_zone_admin OR $user->is_admin ) ) {
			$info = $conf['modules']->get_info("domain"); 
                        $items[] = "<a href=\"" . $conf['web_path'] . "/modules/domain.php?action=show_migrate_zone\">Migrate to ". $info['dest'] ."</a>";
                } //check for migration need
	
		//The Host Tools
		

		$items[] = "<a href=\"" . $conf['web_path'] . "/host.php?action=show_hosts\">Show Hosts</a>";
                if (!$user->is_guest) { 
			$items[] = "<a href=\"" . $conf['web_path'] . "/create_host.php\">Create a new Host</a>"; 
			$items[] = "<a href=\"" . $conf['web_path'] . "/host.php?action=select_bulk_update\">Batch Host Update</a>";
			$items[] = "<a href=\"" . $conf['web_path'] . "/host.php?action=select_bulk_delete\">Batch Host Delete</a>";
		} //if they aren't a guest

		$conf['ui']->display_widget($items,"Manage Hosts",$width);
		/********************************************************/
		echo "\n<br />\n";
		$items = false;

		/* NOT USED
		$items[] = "<a href=\"" . $conf['web_path'] . "/domain.php?action=show_soa_records\">Show SOA records.</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/domain.php?action=show_create_primary_domain\">Create new Primary Domain.</a>";
		*/

		if ($conf['modules']->modules['domain']->enabled AND ( $user->is_admin OR $user->is_zone_admin ) ) {
			if (!$item ) { $item = $conf['modules']->get_info("domain"); }

	                $items[] = "<a href=\"" . $conf['web_path'] . "/modules/domain.php?action=show_domain_add\">Add " . $item['dest'] . " Domain.</a>";
		}

                $cname_link = "CNAMES: <a href=\"" . $conf['web_path'] . "/cname.php?action=show_cnames\">Show</a>";
                $mx_link = "MX: <a href=\"" . $conf['web_path'] . "/mx.php?action=show_mxs\">Show</a>";
		$pointer_link = "Pointers: <a href=\"" . $conf['web_path'] . "/pointer.php?action=show_pointers\">Show</a>";
		if (!$user->is_guest) {
	                $cname_link .= " | <a href=\"" . $conf['web_path'] . "/create_cname.php\">Create</a>";
	                $mx_link .= " | <a href=\"" . $conf['web_path'] . "/create_mx.php\">Create </a>";
		} //if not guest
		// if they are an admin
		if ($user->is_zone_admin || $user->is_admin) { 
			$pointer_link .= " | <a href=\"" . $conf['web_path'] . "/pointer.php?action=show_create_pointer\">Create</a>";
		}
		$items[] = $pointer_link;
		$items[] = $cname_link;
		$items[] = $mx_link;
		$items[] = "Workgroups: <a href=\"" . $conf['web_path'] . "/workgroup.php?action=show_workgroups&amp;zone_id=" . $conf['zone']->id . "\">Show</a>";
		$items[] = "Domains: <a href=\"" . $conf['web_path'] . "/domain.php?action=show_domains&amp;&zone_id=" . $conf['zone']->id . "\">Show</a>";

                $conf['ui']->display_widget($items,"Manage Other Objects",$width);
		/***************************************************************/
		$items = false;
		echo "\n<br />\n";

		$items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_unregistered_hosts\">Show Unregistered Hosts</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_confused_hosts\">Show Incorrectly Registered Hosts</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/range.php?action=show_zone_range_mapping\">View IP Address Usage</a>";
		$items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=show_history\">Show " . $conf['zone']->name . " history</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/csv.php\">Email a CSV of my Zone</a>";

		if ($user->is_zone_admin || $user->is_admin) {
	                $items[] = "<a href=\"" . $conf['web_path'] . "/request_domain.php\">Request a new Domain</a>";
		} //if they are zone or full admin

		if ($conf['modules']->modules['flo']->enabled ) {

			$info = $conf['modules']->get_info("flo");

	                //generate yesterdays date exactly.. ugg
	                $date = strtotime ("-1 day 23:59:00");
			$items[] = "<a href=\"". $conf['web_path'] . 
				"/modules/flo.php?action=show_top_zone&amp;date=$date&amp;count=".$info['top_count']."&amp;zone_id=".$conf['zone']->id."\">Bandwidth Report</a>";

		} //end if flo enabled

                $conf['ui']->display_widget($items,"Reporting and Information",$width);
		/********************************************************************/

                } // write

        } // zone_information


        // user_information creater
        function user_information()
        {
                global $user, $conf;

                //setup the table
                $title = "Modify Permissions";
                $width="100%";

                //setup the information

                // setup the links
                $items[] = "<a href=\"" . $conf['web_path'] . "/user.php?action=show_add_user\">Add user to current zone</a>";
                $items[] = "<a href=\"" . $conf['web_path'] . "/user.php?action=show_users\">View/Edit/Delete Users from current zone</a>";
                //display purge mojo if the zone is purgeable!
                if ($conf['zone']->purgeable == "true") {
                        $items[] = "<a href=\"" . $conf['web_path'] . "/zone.php?action=purge&amp;zone_id=" . $conf['zone']->id . "\">Purge Hosts</a>";
                        }
                // this zone is purgeable so show that to the user
                if ( $conf['zone']->purge ) {
                        $zone_id = $conf['zone']->id;
                        $items[] = "<a href=\"" . $conf['web_path'] . "/admin.php?action=purge_zone&amp;zone_id=$zone_id\">Purge this zone</a>";
                }
		
		//check just incase
                if ($user->is_admin || $user->is_zone_admin) { $conf['ui']->display_widget($items,$title,$width); }

        } // user_information



} // class Widget

?>
